#!/usr/bin/perl

###############################################################
#                NOT FOR PUBLIC DISTRIBUTION!                 #
###############################################################

###############################################################
# Link Admin Install v 1.0 Auto-Installation Script           #
###############################################################
# linkadminInstall.cgi v 1.0 RJ 13-Nov-2001                   #
# This script installs Link Admin.                            #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################

###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################

# Get the current directory
use Cwd;
use DB_File;
$thisDir = cwd;
if ($thisDir !~ /\/$/) { $thisDir .= "/"; }
#if ($thisDir !~ /linkadmin\/$/) { $thisDir .= "linkadmin/"; }

if ($ENV{'DOCUMENT_ROOT'} !~ /\/$/) { $ENV{'DOCUMENT_ROOT'} .= "/"; }

# If this is the first request, we need to collect some information
if ($ENV{'REQUEST_METHOD'} eq "GET") {
	&printHeader;
	print "<p><b>Script Running</b></p>\n<p>";

	print 	"Script Working Directory: <b>$thisDir</b><br>\n".
			"Testing directory is writable: ";

	$CONF{'sendmailLocation'} = `which sendmail`;

	$CONF{'scriptWorkingDir'} = $thisDir;

	# Test the directory is writable
	if (-w $thisDir) { print "<b>Okay</b><br>\n"; }
#	else { print "<b>ERROR! - this directory is not writable</b><br>Exiting ....."; exit; }

	# Check we've got the necessary files
	print	"Retrieving Config List: ";
	if (-e $thisDir . "configList.txt") { print "<b>Okay</b><br>\n"; }
	else { print "<b>ERROR! - Config List missing</b><br>Exiting ....."; exit; }

	print "</p>\n<p>Preliminary checks finished.<br>Enter Configuration values in the form below, the password and click \"Install\" to begin the installation.</p>\n";

	open (CONFIG,"./configList.txt");
	@configFields = (<CONFIG>);
	close (CONFIG);

	print 	"<p><form action=\"$ENV{'REQUEST_URI'}\" method=post><table cellpadding=0 cellspacing=0 bgcolor=\"#000000\"><tr><td>\n".
			"<table cellpadding=4 cellspacing=1>\n".
			"<tr bgcolor=\"#D4D0C8\"><td><b>Submit Script Destination</b></td><td><b></td><td><b>Edit For Testing</b></td>".
			"<td><input type=text name=\"submitScriptDest\" size=60 value=\"$ENV{'DOCUMENT_ROOT'}\"></td></tr>\n".
			"<tr bgcolor=\"#D4D0C8\"><td><b>SPM Script Destination</b></td><td><b></td><td><b>Directory only</b></td>".
			"<td><input type=text name=\"spmScriptDest\" size=60 value=\"$ENV{'DOCUMENT_ROOT'}\"></td></tr>\n";

	foreach (@configFields) {
		chop($_);
		($fieldComment,$fieldDescription,$fieldName,$fieldValue) = split(/\t/,$_);
		while ($fieldValue =~ /%%([a-z]+):([a-z\._]+):([a-z]*):([a-z0-9]*)%%/ig) {
			undef $toReplaceWith;
			$insertDataType = $1;
			$insertDataKey = $2;
			if ($insertDataType =~ /^CONF/) { $toReplaceWith = $CONF{$insertDataKey}; }
			elsif ($insertDataType =~ /^INFO/) { $toReplaceWith = $INFO{$insertDataKey}; }
			elsif ($insertDataType =~ /^DATA/) { $toReplaceWith = $DATA{$insertDataKey}; }
			elsif ($insertDataType =~ /^ENV/) { $toReplaceWith = $ENV{$insertDataKey}; }
			$fieldValue =~ s/%%$insertDataType:$insertDataKey:$insertFieldType:$insertFieldValue%%/$toReplaceWith/g;
		}
		print "<tr bgcolor=\"#D4D0C8\"><td><b>$fieldName</b></td><td>$fieldDescription</td><td><b>$fieldComment</b></td>";
		if ($fieldValue =~ /\"/) {
			print 	"<td><textarea name=\"$fieldName\" rows=1 cols=30 wrap=off>$fieldValue</textarea></td></tr>\n";
		}
		else { print "<td><input type=text name=\"$fieldName\" size=60 value=\"$fieldValue\"></td></tr>\n"; }
	}
	print	"</table></td></tr></table></p>\n".
			"<p><table cellpadding=0 cellspacing=0 bgcolor=\"#000000\"><tr><td>\n".
			"<table cellpadding=4 cellspacing=1>\n".
			"<tr bgcolor=\"#D4D0C8\"><td><b>Installation Password:</b></td>".
			"<td><input type=text name=\"usInstallationPassword\" size=30></td></tr>\n".
			"</table></td></tr></table></p>\n".
			"<p><input type=submit value=Install></form></p></body></html>\n";
}


else {

	&parseFormInput;
	&printHeader;
	print "<p><b>Script Running</b></p>\n";

	# This is where we start to process stuff
	print	"Retrieving Config List: ";
	if (-e $thisDir . "configList.txt") { print "<b>Okay</b><br>\n"; }
	else { print "<b>ERROR! - Config List missing</b><br>Exiting ....."; exit; }

	open (CONFIG,"./configList.txt");
	@configFields = (<CONFIG>);
	close (CONFIG);

	# Create the config DBM file
	print "</p>\n<p>Creating Config File:</b>\n";
	
	unless (dbmopen (%CONF,"$in{'scriptWorkingDir'}config/core.Config",0766)) { print "<b>ERROR! - Could not create config file</b><br>Exiting ....."; exit; }

	foreach (@configFields) {
		($d,$d,$fieldName,$d) = split(/\t/,$_);
		$CONF{$fieldName} = $in{$fieldName};
	}
	
	print "<b>Okay</b></p>\n<p><b>Retrieving and Copying Files:</b><br>\n";

	# Create the auth db file and sort out the writable problem
	dbmopen (%AUTH,"$in{'scriptWorkingDir'}config/core.Auth",0766);dbmclose (%AUTH); dbmclose (%CONF);
	chmod (0766,"$in{'scriptWorkingDir'}config/core.Config.db","$in{'scriptWorkingDir'}config/core.Auth.db");

	print 	"<p><b>Custom Scripts should now be uploaded.</b></p>\n".
			"<p><b><a href=\"index.cgi\" target=_blank>Link Admin Main Page</a></b></p>\n".
			"<p><b><a href=\"../spm/spm.cgi\" target=_blank>SPM</a></b></p>\n</body></html>";
			

}


# Parse the input from the form
sub parseFormInput {

	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/\cM//g;
		if ($name =~ /HTML$/) { $value =~ s/\"/&quot;/g; }
		$in{$name} = $value;
	}

}


sub printHeader {

	print "Content-type: text/html\n\n";
	print <<"END";
	<html>
	<head>

	<title>UsefulScripts.com Installation Script</title>

	<style Type="Text/CSS">
	<!--
		a.menu 			{text-decoration: none; color: #FFFFFF;}
		BODY,TD,P		{font-family:Verdana;font-size:8pt}
		A				{font-family:Verdana;font weight: bold;text-decoration: none;font-size:8pt}
		A:hover 		{text-decoration: underline;font-size:8pt}
		a.menu:hover	{text-decoration: none; color: #FFFFFF;font-size:8pt}
	//-->
	</style>

	</head>
	<body bgColor="#FFFFFF" Link="#0000FF" aLink="#FF0000" vLink="#0000FF" Text="#000000">

END
}

