$DATA{'module.AuthRestrict.Version'} = "1.0";

###############################################################
# Auth Restrict v 1.0 Restricts Access To Part Of The Script  #
###############################################################
# module.AuthRestrict.pl v 1.0 RJ 15-Nov-2001                 #
# This contains shared functions for restricting access to    #
# parts of the script to only authorised reviewers.           #
#                                                             #
# For further information please visit:                       #
# http://www.UsefulScripts.com/                               #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################


###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################

###############################################################
#                     SHARED SUB ROUTINES                     #
###############################################################


# Areas which can be restricted
@restrictedAreas = ('AuthRestrict','Main','Review','Search','Modify','MultiReject','Add','MultiReviewer','Refresh','Blocked','Categories','Templates','Reasons','Configure','Formhtml','Purge');
%restrictedAreas = (
	AuthRestrict		=>	'Set Authorisations (this page)',
	Main				=>	'Main Index Page',
	Review				=>	'Link Reviews',
	Search				=>	'Search Links',
	Modify				=>	'Modify Links',
	MultiReject			=>	'Multi Reject From Search',
	Add					=>	'Add A New Link',
	MultiReviewer		=>	'Reviewer Logs/Reports',
	Refresh				=>	'Refresh Pages',
	Blocked				=>	'Maintained Blocked List',
	Categories			=>	'Maintain Category List',
	Templates			=>	'Maintain Email Templates',
	Reasons				=>	'Maintain Rejection Reasons',
	Configure			=>	'Set Configuration Options',
	Formhtml			=>	'Submission Form HTML',
	Purge				=>	'Expired Links Purge'
);


# Been called as a standalone module
sub runModule {

	# Load in the authorisation file.
	dbmopen (%AUTH,"./config/core.Auth",0777);

	if ($processAction eq "save") {
		# Get blank authorisations first
		foreach $restrictedArea (@restrictedAreas) {
			$tempAUTH{$restrictedArea} = ":";
		}

		while (($key,$val) = each %in) {
			if ($key =~ /^auth/) {
				$key =~ s/^auth//g;
				($authArea,$authUser) = split(/:/,$key);
				if ($val) { $tempAUTH{$authArea} .= "$authUser\:"; }
			}
		}

		# Test the 2 minimum required ones have someone in
		if ($in{'enableAuthRestrictions'} && ($tempAUTH{'Configure'} eq ":" || $tempAUTH{'AuthRestrict'} eq ":")) {
			&printErrorMessage($englishErrorMessages{"configureErrorPrefix"},"<li>".$englishErrorMessages{"authFieldsRequired"}."\n");
			exit;
		}
		else {
			$CONF{'enableAuthRestrictions'} = $in{'enableAuthRestrictions'};
			foreach $restrictedArea (@restrictedAreas) {
				$AUTH{$restrictedArea} = $tempAUTH{$restrictedArea};
			}

			$INFO{'showMessage'} = "<p><table cellspacing=0 cellpadding=0 border=0 align=center width=600><tr><td valign=top width=35 align=left><img src=\"$CONF{'laImageDir'}tickWhite.gif\" height=29 width=29></td><td><font size=2><b>Changes Saved</b><br>The new access restrictions have been saved.</td></tr></table></p>\n";
		}			

	}

	# We need to read the .htaccess file and get the password file
	open (FILE,"$CONF{'scriptWorkingDir'}.htaccess");
	while (<FILE>) { 
		if ($_ =~ /^AuthUserFile(\s+)(.*)/i) { $passwordFile = $2; }
	}
	close (FILE);

	open (PWF,$passwordFile);
	while (<PWF>) { 
		($user,$d) = split (/:/,$_);
		push (@users,$user);
	}
	close (PWF);

	# Construct the list of users for display
	@users = sort(@users);
	foreach (@users) {
		$user = $_;
		$INFO{'userList'} .= "<td valign=bottom align=center bgColor=\"#6699e0\"><font size=2 color=\"#FFFFFF\"><b>";
		while ($user =~ /^([a-z]){1}/i) { $INFO{'userList'} .= "$1<br>"; $user =~ s/^([a-z]){1}//ig; }
		$INFO{'userList'} .= "</b></font></td>\n";
	}


	foreach (@restrictedAreas) {
		$INFO{'authList'} .= "<tr><td valign=bottom bgColor=\"#6699e0\"><font size=2 color=\"#FFFFFF\"><b>$restrictedAreas{$_}</b></font></td>";
		foreach $user (@users) {
			$INFO{'authList'} .= "<td align=center bgColor=\"#6699e0\"><input type=checkbox name=\"auth$_\:$user\" value=1 ";
			if ($AUTH{$_} =~ /:$user\:/) { $INFO{'authList'} .= "checked"; }
			$INFO{'authList'} .= "></td>\n";
		}
		$INFO{'authList'} .= "</tr>\n";
	}

	&displayPage("AdminAuthrestrict",$INFO{'showMessage'});

}

1;
