$DATA{'module.LinkCheck.Version'} = "1.2";

###############################################################
# Link Admin v 1.2 Core Reciprocal Link Checking File         #
###############################################################
# core.RecipCheck.pl v 1.2 RJ 06-Dec-2001                     #
# This contains functions for the checking of reciprocal      #
# links.                                                      #
#                                                             #
# For further information please visit:                       #
# http://www.UsefulScripts.com/                               #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################

# Version 1.2 24-Jan-2002
# Added functionality to check domain name without "-" (for alternative domains)
# Version 1.1 07-Dec-2001
# Added routine to re-check 302 redirections for omitted trailing "/"
# Version 1.0 06-Dec-2001
# Original script


###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################


# Check the status of the site
sub checkLinkStatus {

	$urlToTest = shift;

	if ($urlToTest !~ m|http://([^/]*)/|) { $urlToTest .= "/"; }
	$urlToTest =~ m|http://([^:/]+):?([0-9]*)/(.*)|ig;
	$host = $1;
	$port = $2;
	$path = "/" . $3;

	unless ($port) { $port = 80; }

	require IO::Socket;
	local($^W) = 0;
	my $sock = IO::Socket::INET->new(PeerAddr => $host, PeerPort => $port, Proto    => 'tcp', Timeout  => 5) || return 0;
	$sock->autoflush;
	$host .= ":$port" if $port != 80;
	print $sock join("\015\012" =>
					"HEAD $path HTTP/1.1",
					"Host: $host",
					"User-Agent: Link Admin Link Checker v $DATA{'module.LinkCheck.Version'} UsefulScripts.com",
					"", "");

	my $buf = "";
	my $n;
	1 while $n = sysread($sock, $buf, 8*1024, length($buf));
	@pageResponse = split (/\n/,$buf);

	foreach (@pageResponse) { $_ =~ s/^\s*(.*?)\s*$/$1/; if ($_ =~ m|^Location: (.*)|) { $newLocation = $1; } }
	@pageResponse[0] =~ s/^HTTP\/([0-9]+)\.([0-9]+)//i;
	@pageResponse[0] =~ s/^\s*(.*?)\s*$/$1/;

	if (@pageResponse[0] =~ /^301/ || @pageResponse[0] =~ /^302/) { @pageResponse[0] . " - Correct URL: $newLocation"; }

	if ((@pageResponse[0] =~ /^301/ || @pageResponse[0] =~ /^302/) && !$alreadyRedirected) {
		# Try it with a trailing "/"
		$originalStatus = @pageResponse[0];
		$urlToTest .= "/";
		$alreadyRedirected = 1;
		$newSiteStatus = &checkLinkStatus($urlToTest);
		if ($newSiteStatus =~ /^200/ || $newSiteStatus =~ /^302 Found/) { $in{'siteURL'} = $urlToTest; return $newSiteStatus; }
		else { return $originalStatus; }
	}

	else { return @pageResponse[0]; }

}


# Check for the existence of a reciprocal link
sub checkRecipLink {

	$urlToTest = shift;

	if ($urlToTest !~ m|http://([^/]*)/|) { $urlToTest .= "/"; }
	$urlToTest =~ m|http://([^:/]+):?([0-9]*)/(.*)|ig;
	$host = $1;
	$port = $2;
	$path = "/" . $3;

	unless ($port) { $port = 80; }

	require IO::Socket;
	local($^W) = 0;
	my $sock = IO::Socket::INET->new(PeerAddr => $host, PeerPort => $port, Proto    => 'tcp', Timeout  => 5) || return 0;
	$sock->autoflush;
	$host .= ":$port" if $port != 80;
	print $sock join("\015\012" =>
					"GET $path HTTP/1.1",
					"Host: $host",
					"User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)",
					"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*",
					"Accept-Language: en-gb",
					"Connection: keep-alive",
					"Referer: $urlToTest",
					"", "");

	my $buf = "";
	my $n;
	1 while $n = sysread($sock, $buf, 8*1024, length($buf));
	# Check for redirects
	@recipPageResponse = split (/\n/,$buf);
	@recipPageResponse[0] =~ s/^HTTP\/([0-9]+)\.([0-9]+)//i;
	@recipPageResponse[0] =~ s/^\s*(.*?)\s*$/$1/;

	$responses .= "$buf - $host:$port$path : " . @recipPageResponse[0] . "<br>\n";

	if ((@recipPageResponse[0] =~ /^301/ || @recipPageResponse[0] =~ /^302/) && !$recipAlreadyRedirected) {
		# Try it with a trailing "/"
		$urlToTest .= "/";
		$recipAlreadyRedirected = 1;
		$newRecipStatus = &checkRecipLink($urlToTest);
		if ($newRecipStatus) { $in{'recipURL'} = $urlToTest; }
		return $newRecipStatus;
	}

	else {
		$buf =~ s/.+?\015?\012\015?\012//s;  # zap header
		$pageHTML = $buf;
		$pageHTML =~ s/\n/ /g;
		$pageHTML =~ s/\s+$*/ /g;
		$pageHTML =~ s/  / /g;

		$tempURL = $recipURLalt = $CONF{'checkRecipURL'};
		$recipURLalt =~ s|\-||g;
		$tempRecipURLalt = $recipURLalt;
		if ($tempURL =~ m|^http://www\.|) { $tempURL =~ s|^http://www\.|http://|g; }
		else { $tempURL =~ s|^http://|http://www\.|g; }
		if ($tempRecipURLalt =~ m|^http://www\.|) { $tempRecipURLalt =~ s|^http://www\.|http://|g; }
		else { $tempRecipURLalt =~ s|^http://|http://www\.|g; }
		if ($pageHTML =~ m|<a([^>]*)href(\s?)=(\s?)(["']?)$CONF{'checkRecipURL'}([^>]*)>(.*)</a>|isg ||
			$pageHTML =~ m|<a([^>]*)href(\s?)=(\s?)(["']?)$tempURL([^>]*)>(.*)</a>|isg ||
			$pageHTML =~ m|<a([^>]*)href(\s?)=(\s?)(["']?)$recipURLalt([^>]*)>(.*)</a>|isg ||
			$pageHTML =~ m|<a([^>]*)href(\s?)=(\s?)(["']?)$tempRecipURLalt([^>]*)>(.*)</a>|isg) { return 1; } 
		else { return 0; }
	}
}


1;
