$DATA{'module.MultiReviewer.Version'} = "1.1";

###############################################################
# Multi Reviewer v 1.1 Multiple Review Library File           #
###############################################################
# module.MultiReviewer.pl v 1.1 RJ 04-Mar-2002                #
# This contains shared functions for the manipulation of data #
# relating to multiple reviewers.                             #
#                                                             #
# For further information please visit:                       #
# http://www.UsefulScripts.com/                               #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################


# Version 1.1 04-Mar-2002
# Modified the link review elements to show only non-friends in the "General"
# Version 1.0 13-Nov-2001
# Original script


###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################

###############################################################
#                     SHARED SUB ROUTINES                     #
###############################################################

# Been called as a standalone module
sub runModule {
	unless ($in{'days'}) { $in{'days'} = 7; }
	$INFO{'days'} = $in{'days'};

	# Get the base date for the day 14 days ago
	($d,$d,$d,$dyT,$mnT,$yrT,$d,$d,$d) = localtime(time - (86400 * $in{'days'}));
	use Time::Local;
	$startZeroHour = timelocal(0,0,0,$dyT,$mnT,$yrT);

#	$timeReviewFrom = time() - ($in{'days'} * 86400);
	&currentReviewers;
	while (($key,$val) = each (%currentReviewer)) { 
		$INFO{'currentReviewers'} .= "<b>$key</b><br>\n";
	}

	$x=0; while (@linksFieldOrder[$x] ne "reviewer") { $x++; }
	$y=0; while (@linksFieldOrder[$y] ne "timeReviewed") { $y++; }

	# Get number of rejected submissions by each reviewer
	open (REJECTS,"$CONF{'scriptWorkingDir'}data/data.RejectedLinks.txt"); 
	@rejectedLinks = (<REJECTS>);
	close (REJECTS);
	reverse(@rejectedLinks);
	foreach (@rejectedLinks) { 
		chop($_);
		@tempLinkData = split (/\t/,$_);
		if (@tempLinkData[$y] > $startZeroHour) { 
			($d,$d,$d,$dyT,$mnT,$yrT,$d,$d,$d) = localtime(@tempLinkData[$y]);
			$thisDate = $mnT . "-" . $dyT;

			$reviewedBy = @tempLinkData[$x];
			$reviewerSeen{$reviewedBy} = 1;
			$reviewerToLog = $reviewedBy . ":" . $thisDate;

			$totalReviews{$reviewerToLog}++;
			$overallTotal{$thisDate}++;
			$overallTotal{$reviewedBy}++;
		}
	}

	# Get number of accepted submissions by each reviewer
	open (ACCEPTS,"$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); 
	@acceptedLinks = (<ACCEPTS>);
	close (ACCEPTS);
	foreach (@acceptedLinks) { 
		chop($_);
		@tempLinkData = split (/\t/,$_);
		if (@tempLinkData[$y] > $startZeroHour) { 
			($d,$d,$d,$dyT,$mnT,$yrT,$d,$d,$d) = localtime(@tempLinkData[$y]);
			$thisDate = $mnT . "-" . $dyT;

			$reviewedBy = @tempLinkData[$x];
			$reviewerSeen{$reviewedBy} = 1;
			$reviewerToLog = $reviewedBy . ":" . $thisDate;

			$totalReviews{$reviewerToLog}++;
			$overallTotal{$thisDate}++;
			$overallTotal{$reviewedBy}++;
		}
	}

	while (($key,$val) = each (%reviewerSeen)) { push (@reviewers,$key); }

	@reviewers = sort(@reviewers);	

	# Set up the dates
	@monthsShort = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	for ($z=$in{'days'}; $z>=0; $z--) {
		($d,$d,$d,$dyT,$mnT,$yrT,$d,$d,$d) = localtime($startZeroHour + ($z * 86400));
		$INFO{'dateList'} .= "<td bgColor=\"#6699e0\" align=center><font size=2 color=\"#FFFFFF\"><b>@monthsShort[$mnT]<br>$dyT</b></td>\n";
		$thisDate = $mnT . "-" . $dyT;
		push (@dates,$thisDate);
	}

	foreach (@reviewers) {
		$INFO{'reviewerStats'} .= "<tr><td bgColor=\"#6699e0\"><font size=2 color=\"#FFFFFF\"><b>$_</b></td>";
		foreach $date (@dates) { 
			$INFO{'reviewerStats'} .= "<td bgColor=\"#6699e0\" align=right><font size=2 color=\"#FFFFFF\">" . $totalReviews{$_ . ":" . $date} . "</td>\n";
		}
		$INFO{'reviewerStats'} .= "<td bgColor=\"#6699e0\" align=right><font size=2 color=\"#FFFFFF\"><b>" . $overallTotal{$_} . "</b></td>\n";
	}
	foreach $date (@dates) { 
		$INFO{'totalStats'} .= "<td bgColor=\"#6699e0\" align=right><font size=2 color=\"#FFFFFF\"><b>" . $overallTotal{$date} . "</b></td>\n";
		$INFO{'overallTotal'} += $overallTotal{$date};
	}
	
	&displayPage("AdminMultireviewer",$INFO{'showMessage'});

}


# Get the links which have already been issued to other reviewers
sub getExclusions {
	open (LOG,$CONF{'scriptWorkingDir'} . "data/data.ReviewLog.txt"); 
	while (<LOG>) { 
		chop ($_);
		($reviewLinkNumber,$reviewReviewer,$reviewTime) = split (/\t/,$_);
		if ($reviewTime > (time() - 900) && $reviewReviewer ne $in{'thisReviewer'}) { $linkIssued{$reviewLinkNumber} = 1; }
	}
	close (LOG);
}


# Save the newly issued submissions to prevent duplicate reviews
sub saveExclusions {

	# Log the new ones first
	open (LOG,">>$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt"); &wLock('LOG');
	foreach (@linksReviewed) { print LOG "$_\t$in{'thisReviewer'}\t" . time() . "\n"; }
	&unLock('LOG'); close (LOG);

	# Trim the old ones
	open (TEMPLOG,">$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt.tmp"); &wLock('TEMPLOG');
	open (LOG,$CONF{'scriptWorkingDir'} . "data/data.ReviewLog.txt");
	while (<LOG>) { 
		chop ($_);
		($reviewLinkNumber,$reviewReviewer,$reviewTime) = split (/\t/,$_);
		if ($reviewTime > (time() - 900)) { print TEMPLOG "$_\n"; }
	}
	close (LOG);
	&unLock('TEMPLOG'); close (TEMPLOG);
	rename ("$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt.tmp","$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt");
}


# Remove any link information relating to this reviewer, when they log out
sub clearExclusions {

	# Read through all the records
	open (TEMPLOG,">$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt.tmp"); &wLock('TEMPLOG');
	open (LOG,$CONF{'scriptWorkingDir'} . "data/data.ReviewLog.txt");
	while (<LOG>) { 
		chop ($_);
		($d,$reviewReviewer,$d) = split (/\t/,$_);
		if ($reviewReviewer ne $in{'thisReviewer'}) { print TEMPLOG "$_\n"; }
	}
	close (LOG);
	&unLock('TEMPLOG'); close (TEMPLOG);
	rename ("$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt.tmp","$CONF{'scriptWorkingDir'}data/data.ReviewLog.txt");
}


# Get the reviewers active in the last 15 minutes
sub currentReviewers {
	open (LOG,$CONF{'scriptWorkingDir'} . "data/data.ReviewLog.txt");
	while (<LOG>) { 
		chop ($_);
		($reviewLinkNumber,$reviewReviewer,$reviewTime) = split (/\t/,$_);
		if ($reviewTime > (time() - 900)) { $currentReviewer{$reviewReviewer} = 1; }
	}
	close (LOG);
}	


# Get the total submissions available to this reviewer
sub getReviewableLinks {
	&getExclusions;
	open (SUBLINKS,"$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt"); 
	@submittedLinks = (<SUBLINKS>);
	close (SUBLINKS);
	$friendsSites = "0";
	$x=0; while (@linksFieldOrder[$x] ne "friendSite") { $x++; }
	$y=0; while (@linksFieldOrder[$y] ne "linkNumber") { $y++; }
	$reviewableFriendsSites = "0";
	$reviewableSites = "0";
	foreach (@submittedLinks) { 
		@tempLinkData = split (/\t/,$_);
		$reviewLinkNumber = @tempLinkData[$y];
		if (!$linkIssued{$reviewLinkNumber}) {
			if (@tempLinkData[$x]) { $reviewableFriendsSites++; }
			else { $reviewableSites++; }
		}
	}
	return ($reviewableSites,$reviewableFriendsSites);
}

1;
