#!/usr/bin/perl
$DATA{'module.Refresh.Version'} = "1.1";

###############################################################
# Link Admin v 1.0 Text Data Format Link Refresh File         #
###############################################################
# module.refresh.pl v 1.0 RJ 13-Nov-2001                      #
# This contains the functions to refresh the links pages.     #
#                                                             #
# For further information please visit:                       #
# http://www.UsefulScripts.com/                               #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################

# Version 1.1 26-Jan-2004
# Added additional code for new version of Perl handling DBM files

###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################

# If this is not called over the web (i.e. by cron) we need to
# get the location actual config file

use DB_File;

if (!$DATA{'core.Library.Version'}) {
	use File::Basename;
	$thisDir = (fileparse($0)) [1];

	# Work out the script working directory
	$baseDir = $thisDir;
	$baseDir =~ s/library([\/\\]){1}$//;

	if (!$baseDir) { $baseDir = "."; }

	# Load up the config file (this is only done not over the web)
	dbmopen (%CONF,"$baseDir"."config/core.Config",0777);

	# Load in the core library containing shared functions (this is only done not over the web)
	require ($CONF{'scriptWorkingDir'} . "library/core.Library.pl");

	$result = &refreshPages;
	print $result;
}

sub refreshPages {

	$totalLinks = "0";
	$newLinks = "0";

	# Load in the module for the specific type of data storage being used
	require ($CONF{'scriptWorkingDir'} . "library/module." . $CONF{'dataStorage'} . ".pl");

	# Get all the valid links
	@validLinks = &getValidLinks($CONF{'linkOrder'},$CONF{'linkReverse'});

	# Read through all the links and prepare the HTML for the link 
	# and put it in the right text
	foreach (@validLinks) {

		undef $DATA{'newLink'};
		undef $DATA{'NEWIMAGE'};
		undef $DATA{'HOTIMAGE'};
		undef $DATA{'RECOMMENDIMAGE'};

		# Name all the data
		@tempLinkInfo = split (/\t/,$_);
		for ($x=0; $x < scalar (@linksFieldOrder); $x++) { $fieldName = @linksFieldOrder[$x]; $fieldName =~ tr/a-z/A-Z/; $DATA{$fieldName} = @tempLinkInfo[$x+1]; }
		$tempLinkText = $CONF{'linkFormatHTML'};

		# Do some preliminary data preparation
		if ($DATA{'MOUSEOVERTEXT'}) {
			# We append the mouseover javascript to the link URL - we assume the link URL is put in ""
			$DATA{'LINKURL'} .= "\" onMouseOver=\"window.status='$DATA{'MOUSEOVERTEXT'}';return true\" onMouseOut=\"self.status='';return true";
		}
		$DATA{'LINKDATE'} =	&formatTimestamp($DATA{'TIMEREVIEWED'},"date");

		# Work out the case for the link name displays
		if ($CONF{'siteNameFormat'} eq "UC") { $DATA{'LINKNAME'} =~ tr/a-z/A-Z/; }
		elsif ($CONF{'siteNameFormat'} eq "LC") { $DATA{'LINKNAME'} =~ tr/A-Z/a-z/; }
		elsif ($CONF{'siteNameFormat'} eq "PC") {
			$DATA{'LINKNAME'} =~ s/(\w+)/\u\L$1/g;
			# Fix a problem with '
			$DATA{'LINKNAME'} =~ s/\'([A-Z]){1}/\'\L$1/g; 
			# Fix a problem with Xxx
			$DATA{'LINKNAME'} =~ s/xxx/XXX/ig;
			# Fix a problem with Bdsm
			$DATA{'LINKNAME'} =~ s/bdsm/BDSM/ig;
		}
		elsif ($CONF{'siteNameFormat'} eq "FO") { 
			$DATA{'LINKNAME'} =~ tr/A-Z/a-z/; 
			$DATA{'LINKNAME'} =~ s/([^a-z]*)([a-z])/$1\U$2/i; 
			# Fix a problem with Xxx
			$DATA{'LINKNAME'} =~ s/xxx/XXX/ig;
			# Fix a problem with Bdsm
			$DATA{'LINKNAME'} =~ s/bdsm/BDSM/ig;
		}

		# Work out the case for the link descriptions displays
		if ($CONF{'siteDescriptionFormat'} eq "UC") { $DATA{'LINKDESCRIPTION'} =~ tr/a-z/A-Z/; }
		elsif ($CONF{'siteDescriptionFormat'} eq "LC") { $DATA{'LINKDESCRIPTION'} =~ tr/A-Z/a-z/; }
		elsif ($CONF{'siteDescriptionFormat'} eq "PC") { 
			$DATA{'LINKDESCRIPTION'} =~ s/(\w+)/\u\L$1/g; 
			# Fix a problem with '
			$DATA{'LINKDESCRIPTION'} =~ s/\'([A-Z]){1}/\'\L$1/g; 
			# Fix a problem with Xxx
			$DATA{'LINKDESCRIPTION'} =~ s/xxx/XXX/ig;
			# Fix a problem with Bdsm
			$DATA{'LINKDESCRIPTION'} =~ s/bdsm/BDSM/ig;
		}
		elsif ($CONF{'siteDescriptionFormat'} eq "FO") { 
			$DATA{'LINKDESCRIPTION'} =~ tr/A-Z/a-z/;
			$DATA{'LINKDESCRIPTION'} =~ s/([^a-z]*)([a-z])/$1\U$2/i; 
			# Fix a problem with Xxx
			$DATA{'LINKDESCRIPTION'} =~ s/xxx/XXX/ig;
			# Fix a problem with Bdsm
			$DATA{'LINKDESCRIPTION'} =~ s/bdsm/BDSM/ig;
		}

		# Compare this to the latest reviewed date (get the last updated date
		if ($DATA{'TIMEREVIEWED'} > $lastUpdated) { $lastUpdated = $DATA{'TIMEREVIEWED'}; }

		# If the link was reviewed fewer than $newLinkDuration days ago
		if (time() - $DATA{'TIMEREVIEWED'} <= 86400 * $CONF{'newLinkDuration'}) {
			$DATA{'newLink'} = 1;
			if ($CONF{'displayNewLink'}) { $DATA{'NEWIMAGE'} = $CONF{'newImageHTML'}; }
		}

		# If the link is always new (this avoids it being in the new links for too long
		if ($DATA{'ALWAYSNEW'}) {
			if ($CONF{'displayNewLink'}) { $DATA{'NEWIMAGE'} = $CONF{'newImageHTML'}; }
		}

		# If the link is "hot"
		if ($DATA{'HOTLINK'}) { 
			$DATA{'HOTIMAGE'} = $CONF{'hotImageHTML'};
		}

		# If the link it "recommended"
		if ($DATA{'RECOMMENDLINK'}) { 
			$DATA{'RECOMMENDIMAGE'} = $CONF{'recommendImageHTML'};
		}

		while ($tempLinkText =~ /%%([A-Z]*)%%/) {
			$fieldToReplace = $1;
			$tempLinkText =~ s/%%$fieldToReplace%%/$DATA{$fieldToReplace}/g;
		}

		$thisCat = $DATA{'LINKCATEGORY'};
		$thisSubCat = $DATA{'LINKSUBCATEGORY'};

		$catLinkCount{$thisCat}++;

		# Put the formatted HTML into the various text strings
		$catLinkText{$thisCat} .= $tempLinkText . "\n";
		$catLinkText{$thisCat . ':' . $thisSubCat} .= $tempLinkText . "\n";

		# Split the old from the new
		if ($DATA{'newLink'}) {
			$allNewLinkText .= $tempLinkText . "\n";
			$newLinkText{$thisCat} .= $tempLinkText . "\n";
			$newLinkText{$thisSubCat} .= $tempLinkText . "\n";
			$newLinkText{$thisCat . ':' . $thisSubCat} .= $tempLinkText . "\n";
			$newLinks++;
		}
		# 
		else {
			$oldLinkText{$thisCat} .= $tempLinkText . "\n";
			$oldLinkText{$thisSubCat} .= $tempLinkText . "\n";
			$oldLinkText{$thisCat . ':' . $thisSubCat} .= $tempLinkText . "\n";
		}

		# Increment the total links
		$totalLinks++;

	}

	# Format the last updated date
	$lastUpdatedTime = &formatTimestamp($lastUpdated,"datetime");
	$lastUpdatedDate = &formatTimestamp($lastUpdated,"date");

	# Get all the sub categories
	open (SUBCATS,$CONF{'scriptWorkingDir'} . "data/data.SubCats.txt"); 
	while (<SUBCATS>) { chop($_); push (@subCategories,$_); }
	close (SUBCATS);

	# Now work through all the categories and update the pages
	open (CATS,$CONF{'scriptWorkingDir'} . "data/data.Categories.txt"); 
	@categories = (<CATS>);
	close (CATS);

	foreach $cat (@categories) { 

		($catName,$catFile) = split(/\t/,$cat);

		# If we're to ignore this category
		if ($in{'ignoreRefresh:'.$catName}) { next; }

		undef $pageHTML;
		open (PAGE,"$CONF{'baseHTMLPath'}/$catFile"); while (<PAGE>) { $pageHTML .= $_; } close (PAGE);
		$pageHTML =~ s/\cM//g;

		# Update the last updated date
		$pageHTML =~ s/<!-- begin last updated date -->(.*)<!-- end last updated date -->/<!-- begin last updated date -->$lastUpdatedDate<!-- end last updated date -->/gs;

		# Update the last updated time
		$pageHTML =~ s/<!-- begin last updated time -->(.*)<!-- end last updated time -->/<!-- begin last updated time -->$lastUpdatedTime<!-- end last updated time -->/gs;

		# Update Today's Letter
		$pageHTML =~ s/<!-- begin todays letter -->(.*)<!-- end todays letter -->/<!-- begin todays letter -->$todaysLetter<!-- end todays letter -->/gs;

		# Update the number of links shown per category
		$pageHTML =~ s/<!-- link count -->([0-9]*)/<!-- link count -->$catLinkCount{$catName}/gs;

		# Insert all the category's links 
		$pageHTML =~ s/<!-- begin links -->(.*)<!-- end links -->/<!-- begin links -->\n$catLinkText{$catName}<!-- end links -->/gs;

		# Insert all the category's new links 
		$pageHTML =~ s/<!-- begin links new -->(.*)<!-- end links new -->/<!-- begin links new -->\n$newLinkText{$catName}<!-- end links new -->/gs;

		# Insert all the category's old links 
		$pageHTML =~ s/<!-- begin links old -->(.*)<!-- end links old -->/<!-- begin links old -->\n$oldLinkText{$catName}<!-- end links old -->/gs;

		# Insert the links for each sub category
		foreach $subCat (@subCategories) {
			# All links
			$pageHTML =~ s/<!-- begin links $subCat -->(.*)<!-- end links $subCat -->/<!-- begin links $subCat -->\n$catLinkText{$catName.':'.$subCat}<!-- end links $subCat -->/gs;
			# New links
			$pageHTML =~ s/<!-- begin links new $subCat -->(.*)<!-- end links new $subCat -->/<!-- begin links new $subCat -->\n$newLinkText{$catName.':'.$subCat}<!-- end links new $subCat -->/gs;
			# Old links
			$pageHTML =~ s/<!-- begin links old $subCat -->(.*)<!-- end links old $subCat -->/<!-- begin links old $subCat -->\n$oldLinkText{$catName.':'.$subCat}<!-- end links old $subCat -->/gs;
		}

		# Re-write the new page
		open (PAGE,">$CONF{'baseHTMLPath'}/$catFile"); print PAGE $pageHTML; close (PAGE);

		$pageCount++;

	}

	# Update the new links page
	# If we're to ignore the new links page
	unless ($in{'ignoreRefresh:NewLinksPage'}) {
		undef $pageHTML;
		open (NEWLINKS,$CONF{'newLinksPage'}); while (<NEWLINKS>) { $pageHTML .= $_; } close (NEWLINKS);
		$pageHTML =~ s/\cM//g;

		# Update the last updated date
		$pageHTML =~ s/<!-- begin last updated date -->(.*)<!-- end last updated date -->/<!-- begin last updated date -->$lastUpdatedDate<!-- end last updated date -->/gs;

		# Update the last updated time
		$pageHTML =~ s/<!-- begin last updated time -->(.*)<!-- end last updated time -->/<!-- begin last updated time -->$lastUpdatedTime<!-- end last updated time -->/gs;

		# Update Today's Letter
		$pageHTML =~ s/<!-- begin todays letter -->(.*)<!-- end todays letter -->/<!-- begin todays letter -->$todaysLetter<!-- end todays letter -->/gs;

		# Update the number of new links
		$pageHTML =~ s/<!-- link count -->([0-9]*)/<!-- link count -->$newLinks/gs;

		# Update the number of new links
		$pageHTML =~ s/<!-- link count total -->([0-9]*)/<!-- link count -->$totalLinks/gs;

		# Insert all the new links 
		unless ($CONF{'displayNewLinkNewPage'}) { $allNewLinkText =~ s/$CONF{'newImageHTML'}//gs; }
		$pageHTML =~ s/<!-- begin links -->(.*)<!-- end links -->/<!-- begin links -->\n$allNewLinkText<!-- end links -->/gs;

		# Insert the links for each sub category
		foreach $subCat (@subCategories) {
			unless ($CONF{'displayNewLinkNewPage'}) { $newLinkText{$subCat} =~ s/$CONF{'newImageHTML'}//gs; }
			$pageHTML =~ s/<!-- begin links $subCat -->(.*)<!-- end links $subCat -->/<!-- begin links $subCat -->\n$newLinkText{$subCat}<!-- end links $subCat -->/gs;
		}

		# Re-write the new page
		open (NEWLINKS,">$CONF{'newLinksPage'}"); print NEWLINKS $pageHTML; close (NEWLINKS);

		$pageCount++;

	}

	# Update the main category listing page
	# If we're to ignore the main category page
	unless ($in{'ignoreRefresh:MainCatPage'}) {
		undef $pageHTML;
		open (MAINPAGE,"$CONF{'catListPage'}"); while (<MAINPAGE>) { $pageHTML .= $_; } close (MAINPAGE);
		$pageHTML =~ s/\cM//g;

		# Update the number of links shown per category
		foreach $cat (@categories) { 
			($catName,$catFile) = split(/\t/,$cat);
			$pageHTML =~ s/<!-- link count $catName -->([0-9]*)/<!-- link count $catName -->$catLinkCount{$catName}/gs;
		}

		# Update the last updated date
		$pageHTML =~ s/<!-- begin last updated date -->(.*)<!-- end last updated date -->/<!-- begin last updated date -->$lastUpdatedDate<!-- end last updated date -->/gs;

		# Update the last updated time
		$pageHTML =~ s/<!-- begin last updated time -->(.*)<!-- end last updated time -->/<!-- begin last updated time -->$lastUpdatedTime<!-- end last updated time -->/gs;

		# Update the number of new links
		$pageHTML =~ s/<!-- link count new -->([0-9]*)/<!-- link count new -->$newLinks/gs;

		# Update the total number of links
		$pageHTML =~ s/<!-- link count -->([0-9]*)/<!-- link count -->$totalLinks/gs;

		# Re-write the new page
		open (MAINPAGE,">$CONF{'catListPage'}"); print MAINPAGE $pageHTML; close (MAINPAGE);

		$pageCount++;

	}

	# Update the last refreshed date
	open (LASTREFRESH,">$CONF{'scriptWorkingDir'}data/data.LastRefresh.txt"); 
	print LASTREFRESH time();
	close (LASTREFRESH);

	if ($linkOrder eq "AlphaRotate") { 
		$returnText = "Today's Letter:     " . sprintf ("%5s",$todaysLetter) . "\n";
	}

	$returnText .= 	"Pages Refreshed:    " . sprintf ("%5s",$pageCount) . "\n".
					"Total Links Listed: " . sprintf ("%5s",$totalLinks) . "\n".
					"New Links Listed:   " . sprintf ("%5s",$newLinks) . "\n";

	return ($returnText);
}

1;