$DATA{'module.Text.Version'} = "1.1";

###############################################################
# Link Admin v 1.1 Text Data Storage Library File             #
###############################################################
# module.Text.pl v 1.1 RJ 04-Mar-2002                         #
# This contains shared functions for manipulating data stored #
# in text files.                                              #
#                                                             #
# For further information please visit:                       #
# http://www.UsefulScripts.com/                               #
###############################################################
# Copyright  2001 iNet Publishing Ltd                        #
# Reproduction in part or in whole is strictly prohibited.    #
# This copyright header must not be removed.                  #
# No warranty expressed or implied.                           #
###############################################################


# Version 1.1 04-Mar-2002
# Modified the link review elements to show only non-friends in the "General"
# Version 1.0 13-Nov-2001
# Original script


###############################################################
#           DO NOT EDIT ANYTHING BENEATH THIS LINE!           #
###############################################################

###############################################################
#                     SHARED SUB ROUTINES                     #
###############################################################


# Update the link data
sub updateLink {
	($thisLinkData,$linkNumber,$originalStatus,$siteStatus) = @_;
	
	if ($originalStatus eq "Accepted") { $oldFile = "AcceptedLinks";}
	elsif ($originalStatus eq "Rejected") { $oldFile = "RejectedLinks"; }
	elsif ($originalStatus eq "Pending") { $oldFile = "NewSubmissions"; }

	if ($siteStatus eq "Accepted") { $newFile = "AcceptedLinks";}
	elsif ($siteStatus eq "Rejected") { $newFile = "RejectedLinks"; }
	elsif ($siteStatus eq "Pending") { $newFile = "NewSubmissions"; }

	# First remove the old link
	open (TEMPLINKS,">$CONF{'scriptWorkingDir'}data/data.$oldFile\.txt.tmp"); &wLock('TEMPLINKS');
	open (LINKS,"$CONF{'scriptWorkingDir'}data/data.$oldFile\.txt"); 
	while (<LINKS>) {
		($tempLinkNumber,$d) = split(/\t/,$_);
		if ($tempLinkNumber != $linkNumber) { print TEMPLINKS $_; }
	}
	close (LINKS);
	&unLock('TEMPLINKS'); close (TEMPLINKS);
	rename ("$CONF{'scriptWorkingDir'}data/data.$oldFile\.txt.tmp","$CONF{'scriptWorkingDir'}data/data.$oldFile\.txt");
	chmod ("$CONF{'scriptWorkingDir'}data/data.$oldFile.txt",0777);


	# Add the new link data
	open (LINKS,">>$CONF{'scriptWorkingDir'}data/data.$newFile\.txt"); &wLock('LINKS');
	print LINKS $thisLinkData . "\n";
	&unLock('LINKS'); close (LINKS);
}


# Process/update multiple rejections
sub multiReject {

	# Put the rejected links into a hash
	foreach (@multiReject) { $toMultiReject{$_} = 1; }

	$linksMultiRejected = "0";

	# First do the Accepted Status ones
	if ($fileToProcess{'Accepted'}) {
		# First remove the old links
		open (TEMPLINKS,">$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt.tmp"); &wLock('TEMPLINKS');
		open (LINKS,"$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); 

		$x=0; while (@linksFieldOrder[$x] ne "siteStatus") {$x++;}
		$y=0; while (@linksFieldOrder[$y] ne "listStatus") {$y++;}
		$z=0; while (@linksFieldOrder[$z] ne "timeReviewed") {$z++;}

		while (<LINKS>) {
			chop ($_);
			(@tempLinkInfo) = split(/\t/,$_);
			$tempLinkNumber = @tempLinkInfo[0];
			if (!$toMultiReject{$tempLinkNumber}) { print TEMPLINKS "$_\n"; }
			else { 
				undef ($toAppendToRejects);
				@tempLinkInfo[$x] = "Rejected";
				@tempLinkInfo[$y] = "Invalid";
				@tempLinkInfo[$z] = time();
				foreach $tempLinkInfo (@tempLinkInfo) { $toAppendToRejects .= "$tempLinkInfo\t"; }
				chop ($toAppendToRejects); $toAppendToRejects .= "\n";
				$linksMultiRejected++;
			}
		}
		close (LINKS);
		&unLock('TEMPLINKS'); close (TEMPLINKS);
		rename ("$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt.tmp","$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt");
		chmod ("$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt",0777);
	}

	# Next do the Accepted Status ones
	if ($fileToProcess{'Pending'}) {
		# First remove the old links
		open (TEMPLINKS,">$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt.tmp"); &wLock('TEMPLINKS');
		open (LINKS,"$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt"); 

		$x=0; while (@linksFieldOrder[$x] ne "siteStatus") {$x++;}
		$y=0; while (@linksFieldOrder[$y] ne "listStatus") {$y++;}
		$z=0; while (@linksFieldOrder[$z] ne "timeReviewed") {$z++;}

		while (<LINKS>) {
			chop ($_);
			(@tempLinkInfo) = split(/\t/,$_);
			$tempLinkNumber = @tempLinkInfo[0];
			if (!$toMultiReject{$tempLinkNumber}) { print TEMPLINKS "$_\n"; }
			else { 
				undef ($toAppendToRejects);
				@tempLinkInfo[$x] = "Rejected";
				@tempLinkInfo[$y] = "Invalid";
				@tempLinkInfo[$z] = time();
				foreach $tempLinkInfo (@tempLinkInfo) { $toAppendToRejects .= "$tempLinkInfo \t"; }
				chop ($toAppendToRejects); $toAppendToRejects .= "\n";
				$linksMultiRejected++;
			}
		}
		close (LINKS);
		&unLock('TEMPLINKS'); close (TEMPLINKS);
		rename ("$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt.tmp","$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt");
		chmod ("$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt",0777);
	}
	
	# Save the rejected link data
	open (LINKS,">>$CONF{'scriptWorkingDir'}data/data.RejectedLinks.txt"); &wLock('LINKS');
	print LINKS $toAppendToRejects;
	&unLock('LINKS'); close (LINKS);

	return $linksMultiRejected;

}


# Update the reviewed date to now for those reviewed since this was last run
sub updateReviewedDate {

	# First get the last time this was run
	# If this has been run before get that time
	if (-e "$CONF{'scriptWorkingDir'}data/data.LastImport.txt") {
		open (IMPORTTIME,$CONF{'scriptWorkingDir'} . "data/data.LastImport.txt"); 
		$lastImport = (<IMPORTTIME>);
		close (IMPORTTIME);
	}
	# Otherwise get the time the pages were last refreshed
	else {
		open (REFRESHTIME,$CONF{'scriptWorkingDir'} . "data/data.LastRefresh.txt"); 
		$lastImport = (<REFRESHTIME>);
		close (REFRESHTIME);
	}

	# The time now is
	$importTime = time();

	$linksImported = "0";

	# Get the field for the time reviewed
	$x=0; while (@linksFieldOrder[$x] ne "timeReviewed") {$x++;}

	# Now read through an update all the "older than" links
	open (TEMPLINKS,">$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt.tmp"); &wLock('TEMPLINKS');
	open (LINKS,"$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); 

	while (<LINKS>) {
		chop ($_);
		(@tempLinkInfo) = split(/\t/,$_);
		if (@tempLinkInfo[$x] > $lastImport) { 
			undef($toUpdateWith);
			@tempLinkInfo[$x] = $importTime;
			foreach $tempLinkInfo (@tempLinkInfo) { $toUpdateWith .= "$tempLinkInfo\t"; }
			chop ($toUpdateWith); $toUpdateWith .= "\n";
			print TEMPLINKS $toUpdateWith;
			$linksImported++;
		}
		else { print TEMPLINKS "$_\n"; }
	}

	close (LINKS);
	&unLock('TEMPLINKS'); close (TEMPLINKS);
	rename ("$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt.tmp","$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt");
	chmod ("$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt",0777);

	# Update the last imported date
	open (IMPORTTIME,">$CONF{'scriptWorkingDir'}data/data.LastImport.txt"); 
	print IMPORTTIME $importTime;
	close (IMPORTTIME);
	
	return $linksImported;

}


# Get the data for a specific link
sub getDetail {
	($siteStatus,$linkNumber) = @_;
	if ($siteStatus eq "Accepted") { $searchFile = "AcceptedLinks"; }
	elsif ($siteStatus eq "Rejected") { $searchFile = "RejectedLinks"; }
	elsif ($siteStatus eq "Pending") { $searchFile = "NewSubmissions"; }

	# Get the field for the Link Number
	$x=0; while (@linksFieldOrder[$x] ne "linkNumber") {$x++;}

	# Search the relevant file for the link
	open (FILE,$CONF{'scriptWorkingDir'} . "data/data.$searchFile.txt"); 
	while (<FILE>) {
		chop($_);
		(@tempLinkData) = split (/\t/,$_);
		if (@tempLinkData[$x] == $linkNumber) { last; } 
	}
	close (FILE);

	return (@tempLinkData);
}


# Search the links
sub searchLinks {

	# Get the field numbers for category and sub category (links and submissions)
	$w=0; while (@linksFieldOrder[$w] ne "linkCategory") {$w++;}
	$x=0; while (@linksFieldOrder[$x] ne "linkSubCategory") {$x++;}
	$y=0; while (@linksFieldOrder[$y] ne "siteCategory") {$y++;}
	$z=0; while (@linksFieldOrder[$z] ne "siteSubCategory") {$z++;}

	if ($in{'searchType'} eq "keyword") { @keywords = split (/ /,$in{'keywords'}); }

	# Search the Accepted Links first
	if (!$in{'siteStatus'} || $in{'siteStatus'} eq "Accepted") {
		open (LINKS,$CONF{'scriptWorkingDir'} . "data/data.AcceptedLinks.txt"); 
		while (<LINKS>) {
			chop($_);
			$matchResult = &testLine($_,$w,$x);
			if ($matchResult) { push (@matches,$_); }
		}
		close (LINKS);
	}
	if (!$in{'siteStatus'} || $in{'siteStatus'} eq "Rejected") {
		open (REJECTS,$CONF{'scriptWorkingDir'} . "data/data.RejectedLinks.txt");
		while (<REJECTS>) {
			chop($_);
			$matchResult = &testLine($_,$y,$z);
			if ($matchResult) { push (@matches,$_); }
		}
		close (REJECTS);
	}
	if (!$in{'siteStatus'} || $in{'siteStatus'} eq "Pending") {
		open (NEWSUBS,$CONF{'scriptWorkingDir'} . "data/data.NewSubmissions.txt"); 
		while (<NEWSUBS>) {
			chop($_);
			$matchResult = &testLine($_,$y,$z);
			if ($matchResult) { push (@matches,$_); }
		}
		close (NEWSUBS);
	}

	# If there are more matches than we can list on one page, then trim it down
	$totalMatches = scalar(@matches);
	if ($totalMatches > $matchesPerPage) {
		$startPoint = ($in{'page'} - 1) * $matchesPerPage;
		@matches = splice (@matches,$startPoint,$matchesPerPage);
	}
	return ($totalMatches,@matches);
}

sub testLine {	
	($lineToTest,$categoryField,$subCategoryField) = @_;
	$score = 0;
	if ($in{'searchType'} eq "keyword") { 
		foreach $keyword (@keywords) { 
			if ($lineToTest =~ m|$keyword|i) {
				$score = 1;
				last;
			}
		}
	}
	else { if ($lineToTest =~ m|$in{'keywords'}|i) { $score = 1; } }

	if ($score) { 
		if ($in{'siteCategory'} || $in{'siteSubCategory'}) {
			# Test that the category and sub category match
			@tempLinkData = split(/\t/,$lineToTest);
			if ($in{'siteCategory'} && @tempLinkData[$categoryField] ne $in{'siteCategory'}) { $score = 0; }
			if ($in{'siteSubCategory'} && @tempLinkData[$subCategoryField] ne $in{'siteSubCategory'}) { $score = 0; }
		}
	}
	return $score;
}


# Get submissions for the review page
sub getSubmissions {
	if ($CONF{'multiReviewers'}) { 
		&getExclusions;
	}

	# Identify the field for the friend's site indicator
	$x=0; while (@linksFieldOrder[$x] ne "friendSite") {$x++;}
	$y=0; while (@linksFieldOrder[$y] ne "linkNumber") {$y++;}

	open (SUBMISSIONS,$CONF{'scriptWorkingDir'} . "data/data.NewSubmissions.txt"); 
	while (<SUBMISSIONS>) { 
		if (scalar(@linksToShow) == $CONF{'reviewPageSites'}) { last; }
		@linkData = split(/\t/,$_);
		$linkNumber = @linkData[0];
		$friendSite = @linkData[$x];
		unless (
			$linkIssued{$linkNumber} || 
			($in{'type'} eq "Friends" && !@linkData[$x]) ||
			($in{'type'} eq "General" && @linkData[$x]) ||
			($in{'specificSubmission'} && $linkNumber != $in{'specificSubmission'})
			) { chop($_); push(@linksToShow,$_); push(@linksReviewed,@linkData[$y]); }
	}
	close (SUBMISSIONS);

	if ($CONF{'multiReviewers'}) { 
		&saveExclusions;
	}

}

# Add the link to the accepted links file
sub addLink {

	$dataToAdd = shift;

	# Add the new link
	open (LINKS,">>$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); &wLock('LINKS');
	print LINKS $dataToAdd . "\n";
	&unLock('LINKS'); close (LINKS);

}


# Add the link to the accepted links file
sub rejectLink {

	$dataToAdd = shift;

	# Add the new link
	open (REJECTS,">>$CONF{'scriptWorkingDir'}data/data.RejectedLinks.txt"); &wLock('REJECTS');
	print REJECTS $dataToAdd . "\n";
	&unLock('REJECTS'); close (REJECTS);

}


# Remove the reviewed submission for the submitted (pending review) links file
sub removeSubmissions {

	open (ALLSUBS,">>$CONF{'scriptWorkingDir'}data/data.AllSubmissions.txt"); &wLock('ALLSUBS');
	open (TEMPSUBLINKS,">$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt.tmp"); &wLock('TEMPSUBLINKS');
	open (SUBLINKS,"$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt"); 
	while (<SUBLINKS>) {
		($tempLinkNumber,$d) = split(/\t/,$_);
		if ($linkReviewed{$tempLinkNumber}) { print ALLSUBS $_; }
		else { print TEMPSUBLINKS $_; }
	}
	close (SUBLINKS);
	&unLock('TEMPSUBLINKS'); close (TEMPSUBLINKS);
	&unLock('ALLSUBS'); close (ALLSUBS);
	rename ("$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt.tmp","$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt");
	chmod ("$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt",0777);

}


# Add the submission to the submitted (pending review) links file
sub addSubmission {
	# If the file can be opened then add the new submission
	if (open (SUBLINKS,">>$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt")) {	

		# Get the link number
		$in{'linkNumber'} = &getLinkNumber;

		# Submission time
		$in{'timeSubmitted'} = time();

		foreach (@linksFieldOrder) {
			$dataToAdd .= $in{$_} . "\t";
		}
		chop ($dataToAdd);

		&wLock('SUBLINKS');
		print SUBLINKS $dataToAdd . "\n";
		&unLock('SUBLINKS'); close (SUBLINKS);

		return 1;
	}
	else { return 0; }
}


# Check to see if the submitted URL is already listed or submitted
sub checkIPaddress {

	if (@linksFieldOrder) { 
		$x=0; while (@linksFieldOrder[$x] ne "webmasterIPaddress") {$x++} ;
		$y=0; while (@linksFieldOrder[$y] ne "timeSubmitted") {$y++};

		open (SUBMISSIONS,$CONF{'scriptWorkingDir'} . "data/data.NewSubmissions.txt"); 
		@newSubmissions = (<SUBMISSIONS>);
		close (SUBMISSIONS);
		foreach (@newSubmissions) {
			@siteInfo = split(/\t/,$_);
			if (@siteInfo[$x]  eq $in{'webmasterIPaddress'} && time() - @siteInfo[$y] < 86400) { $multiSub = 1; }
		}
	}

	return $multiSub;
}


# Check to see if the submitted URL is already listed or submitted
sub checkDupURL {
	# Remove or add the "www" from the URL we're testing
	$testURL = $in{'siteURL'};
	$testURL =~ s/http:\/\/www\./http:\/\//gi;
	$testURLWWW = $testURL;
	$testURLWWW =~ s/http:\/\//http:\/\/www\./gi;

	$dupURL = 0;

	# This tests if the URL has been submitted before with or without the trailing "/", with or without the 
	# "www" subdomain and with or without an "index.*" file
	if (@linksFieldOrder) { $x=0; while (@linksFieldOrder[$x] ne "siteURL") {$x++;}
		open (SUBMISSIONS,$CONF{'scriptWorkingDir'} . "data/data.NewSubmissions.txt"); 
		@newSubmissions = (<SUBMISSIONS>);
		close (SUBMISSIONS);
		foreach (@newSubmissions) {
			@siteInfo = split(/\t/,$_);
			if (@siteInfo[$x] =~ m|^$testURL(/?)$|i || @siteInfo[$x] =~ m|^$testURL(/?)index\.([a-z]*)$|i || 
				$testURL =~ m|^@siteInfo[$x](/?)$|i || $testURL =~ m|^@siteInfo[$x](/?)index\.([a-z]*)$|i || 
				@siteInfo[$x] =~ m|^$testURLWWW(/?)$|i || @siteInfo[$x] =~ m|^$testURLWWW(/?)index\.([a-z]*)$|i || 
				$testURLWWW =~ m|^@siteInfo[$x](/?)$|i || $testURLWWW =~ m|^@siteInfo[$x](/?)index\.([a-z]*)$|i )
			{ $dupURL = 1; }
		}
	}


	unless ($dupURL) {
		if (@linksFieldOrder) { $y=0; while (@linksFieldOrder[$y] ne "linkURL") {$y++;}
			open (LINKS,$CONF{'scriptWorkingDir'} . "data/data.AcceptedLinks.txt"); 
			@acceptedLinks = (<LINKS>);
			close (LINKS);
			foreach (@acceptedLinks) {
				@siteInfo = split(/\t/,$_);
				if (@siteInfo[$y] =~ m|^$testURL(/?)$|i || @siteInfo[$y] =~ m|^$testURL(/?)index\.([a-z]*)$|i || 
					$testURL =~ m|^@siteInfo[$y](/?)$|i || $testURL =~ m|^@siteInfo[$y](/?)index\.([a-z]*)$|i || 
					@siteInfo[$y] =~ m|^$testURLWWW(/?)$|i || @siteInfo[$y] =~ m|^$testURLWWW(/?)index\.([a-z]*)$|i || 
					$testURLWWW =~ m|^@siteInfo[$y](/?)$|i || $testURLWWW =~ m|^@siteInfo[$y](/?)index\.([a-z]*)$|i )
				{ $dupURL = 1; }
			}
		}
	}

	return $dupURL;
}

# Return the number of total and friends submissions
sub getSubmittedLinks {
	open (SUBLINKS,"$CONF{'scriptWorkingDir'}data/data.NewSubmissions.txt"); 
	@submittedLinks = (<SUBLINKS>);
	close (SUBLINKS);
	$friendsSites = "0";
	$generalSites = "0";
	$x=0; while (@linksFieldOrder[$x] ne "friendSite") { $x++; }
	$y=0; while (@linksFieldOrder[$y] ne "friendSite") { $y++; }
	foreach (@submittedLinks) { 
		@tempLinkData = split (/\t/,$_);
		if (@tempLinkData[$x]) { $friendsSites++; }
		else { $generalSites++; }
	}

	return ($generalSites,$friendsSites);
}


# Return the number of total links and links waiting to be added
sub getReviewedLinks {
	open (LINKS,"$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); 
	@acceptedLinks = (<LINKS>);
	close (LINKS);
	$totalLinks = "0";
	$linksToAdd = "0";
	$x=0; while (@linksFieldOrder[$x] ne "timeReviewed") { $x++; }
	$y=0; while (@linksFieldOrder[$y] ne "listStatus") { $y++; }
	$z=0; while (@linksFieldOrder[$z] ne "expireAfter") { $z++; }
	foreach (@acceptedLinks) { 
		chop($_);
		@tempLinkData = split (/\t/,$_);
		# If there is a default expire after setting
		if ($CONF{'defaultExpireAfter'} > 0 && time() - @tempLinkData[$x] > 86400 * $CONF{'defaultExpireAfter'}) { 
			# We need to check if the linked expired by the time of the last refresh
			unless ($lastRefresh - @tempLinkData[$x] > 86400 * $CONF{'defaultExpireAfter'}) { $listedLinks++; }
			next;
		}
		# If there is a specific expire after setting
		if (@tempLinkInfo[$z] > 0 && time() - @tempLinkData[$x] > 86400 * @tempLinkInfo[$z]) { 
			# We need to check if the linked expired by the time of the last refresh
			unless ($lastRefresh - @tempLinkData[$x] > 86400 * @tempLinkInfo[$z]) { $listedLinks++; }
			next;
		}
		# If the link is valid
		if (@tempLinkData[$y] eq "Valid") { 
			# If the link has been reviewed since the last refresh time
			if (@tempLinkData[$x] > $lastRefresh) { $linksToAdd++; }
			# Otherwise it's to be added
			else { $listedLinks++; }
			$totalLinks++;
		}
	}
	return ($totalLinks,$listedLinks,$linksToAdd);
}


# Get the new link number
sub getLinkNumber {
	# Get the new link number
	open (LINKNUMBER,"$CONF{'scriptWorkingDir'}data/data.LinkNumber.txt"); 
	$tempLinkNumber = (<LINKNUMBER> + 1);
	close (LINKNUMBER);
	# Record the new link number
	open (LINKNUMBER,">$CONF{'scriptWorkingDir'}data/data.LinkNumber.txt"); &wLock('LINKNUMBER');
	print LINKNUMBER $tempLinkNumber;
	&unLock('LINKNUMBER'); close (LINKNUMBER);
	return $tempLinkNumber;
}


# Return the valid links for listing
sub getValidLinks {
	($linkOrder,$linkReverse) = @_;
	# Work out the field used for sorting the links
	if ($linkOrder eq "AlphaRotate" || $linkOrder eq "AlphaStatic") { $sortField = "sortName"; }
	else { $sortField = "timeReviewed"; }

	open (LINKS,"$CONF{'scriptWorkingDir'}data/data.AcceptedLinks.txt"); 
	@acceptedLinks = (<LINKS>);
	close (LINKS);
	$totalLinks = "0";
	$linksToAdd = "0";
	$x=0; while (@linksFieldOrder[$x] ne "listStatus") { $x++; }
	$y=0; while (@linksFieldOrder[$y] ne "siteStatus") { $y++; }
	$z=0; while (@linksFieldOrder[$z] ne "timeReviewed") { $z++; }
	$i=0; while (@linksFieldOrder[$i] ne "expireAfter") { $i++; }
	# If the link order is not random then work out the actual sort filed
	if ($linkOrder) { $sf=0; while (@linksFieldOrder[$sf] ne $sortField) { $sf++; } }

	foreach (@acceptedLinks) { 
		chop($_);
		@tempLinkData = split (/\t/,$_);
		if (@tempLinkData[$x] eq "Valid" && @tempLinkData[$y] eq "Accepted") {
			# The default expire after is overridden by the setting for the specific link
			unless (@tempLinkData[$i] > 0 && time() - @tempLinkData[$z] > 86400 * @tempLinkData[$i]) {
				# If there is a default expire after setting
				if ($CONF{'defaultExpireAfter'} > 0 && @tempLinkData[$i] < 1) {
					# Unless it has expired
					unless (time() - @tempLinkData[$z] > 86400 * $CONF{'defaultExpireAfter'}) {
						push (@validLinksReturn,@tempLinkData[$sf]."\t$_");
					}
				}
				# If there is no default expire after setting
				else {
					push (@validLinksReturn,@tempLinkData[$sf]."\t$_");
				}
			}
		}
	}

	# Return the links in alpha or date order
	@validLinksReturn = sort @validLinksReturn;

	# If the link order is Random, then shake 'em up a bit
	if ($linkOrder eq "Random") {
		@tempValidLinksReturn = @validLinksReturn;
		$validLinks = scalar (@tempValidLinksReturn);
		undef @validLinksReturn;
		srand(time() ^ ($$ + ($$ << 15)));
		for ($x = 0; $x < $validLinks; $x++) {
			$thisLink = rand(@tempValidLinksReturn);
			push(@validLinksReturn, @tempValidLinksReturn[$thisLink]);
			splice (@tempValidLinksReturn, $thisLink, 1);
		}
	}
	# If the link order is AlphaRotate, then get them in order with the last updated letter
	elsif ($linkOrder eq "AlphaRotate") {
		if (-e "$CONF{'scriptWorkingDir'}data/data.LetterRotate.txt") {
			open (ALPHAFILE,"$CONF{'scriptWorkingDir'}data/data.LetterRotate.txt");
			$todaysLetter = <ALPHAFILE>;
			close (ALPHAFILE);
			# If the letter was last updated 12 or more hours ago we update it
			($letterLastUpdated) = (stat("$CONF{'scriptWorkingDir'}data/data.LetterRotate.txt")) [9];
			if ((time() - $letterLastUpdated) >= 43200) {
				$todaysLetter++;
				$todaysLetter = chop($todaysLetter);
				open (ALPHAFILE,">$CONF{'scriptWorkingDir'}data/data.LetterRotate.txt");
				print ALPHAFILE $todaysLetter;
				close (ALPHAFILE);
			}
		}
		# Otherwise this is the first time
		else { 
			$todaysLetter = "A";
			open (ALPHAFILE,">$CONF{'scriptWorkingDir'}data/data.LetterRotate.txt");
			print ALPHAFILE $todaysLetter;
			close (ALPHAFILE);
		}

		while ($tempCounter <= scalar(@validLinksReturn)) {
			$firstLetter = substr(@validLinksReturn[0],0,1);
			$firstLetter =~ tr/a-z/A-Z/;
			$decValue = ord($firstLetter);

			if ($decValue < ord($todaysLetter)) { 
				$thisLink = shift (@validLinksReturn);
				push (@validLinksReturn,$thisLink);
			}
			else {
				last;
			}
			$tempCounter++;
		}
	}

	# Reverse them if required
	if ($linkReverse) { @validLinksReturn = reverse @validLinksReturn; }

	return (@validLinksReturn);
}




1;
